import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * The game board. The board had a paddle that can move.
 * 
 * @author mik
 * @version 1.0
 */
public class BubbleWorld extends World
{
    private Paddle paddle;
    private Bubble bubble;
    private int livesCount;
    private boolean paddlePower = false;
    private int counter = 0;
    private int startMusic = 0;
    /**
     * Constructor for objects of class Board.
     * 
     */
    public BubbleWorld()
    {    
        
        super(600, 700, 1);//Size of the board
        setPaintOrder (Spike.class);
        livesCount = 3;//the amount of lives given
        paddle = new Paddle();//shows paddle
        bubble = new Bubble();//shows bubbles
        addObject ( paddle, getWidth() / 2, getHeight() - 50);
        newBubbles();
        lives();
        counter();
        
    }
    public void act()
    {
    if (startMusic == 0 )
    
    {
        Greenfoot.playSound("spacerocked.mp3");
        startMusic++;
    }
}
    public boolean checkSpikeNumber()
    {
        if(super.getObjects(Spike.class).size() == 1)
        {
            return true;       
        }
        else
        {
            return false;
        }
        
    }
    
    public void reduceLives()//checks for when you lose a life
    {
        if(checkSpikeNumber())
        {
            livesCount--;
            lives();
        }
    }
    
    public void increaseLives()//checks for when you earn a life, adds a life to your total amount
    {
        livesCount++;
        lives();
    }
    
    public void spikeIsOut()
    {
        if(checkSpikeNumber())//reloads a new spike onto paddle
        {
            paddle.newSpike();
        }
    }
    //Displays the amount of bubbles in the game
    public void newBubbles()
    {
        for (int y = 1; y < 9; y++)
        {
            for (int x = 1; x < 13; x++)
            {
                addObject(new Bubble(), (x*48)- 16, (y*50)); //the spacing of the bubble
            }
        }
    }
    
    public void lives()
    {
        if(livesCount == -1)//When you have no more lives left, Gameover scoreboard shows up
        {
            super.addObject (new ScoreBoard("Game Over! :("), getWidth()/2, getHeight()/2);
            Greenfoot.stop();
        }
        List<Actor> actors = getObjects(LivesAmount.class); 
        for(Actor a : actors) 
        {
            removeObject(a); 
        }
        int x = 580;
        for(int i = 0; i < livesCount; i++)//shows the hearts at the bottom
        {
            super.addObject ( new LivesAmount(), x,678);
            x = x -30;
        }

    }
    
    public void paddlePower()
    {
        paddlePower = true;
        counter = 20;   
    }
    
    public void counter()
    {
        counter--;
        if(counter <= 0)
        {
            paddlePower = false;
        }
    }
    
    public boolean paddlePowerTrue()
    {
        return paddlePower;
    }
    
    public void winGame()//the winning scoreboard shows when you clear all the bubbles
    {
        if(super.getObjects(Bubble.class).size() <= 0)
        {
            super.addObject (new ScoreBoard("You Win! :)"), getWidth()/2, getHeight()/2);
            Greenfoot.stop();
        }
    }
   
}
