import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The game paddle. It is keyboard controlled (left, right, space). It also 
 * generates a new spike when it is created itself.
 * 
 * @author mik
 * @version 1.0
 */
public class Paddle extends Actor
{
    private Spike mySpike;  // used before spike gets released;
    private int reloadDelayCount = 20;
    private static final int gunReloadTime = 20;
    /**
     * When the paddle gets created, create a spike as well.
     */
    public void addedToWorld(World world)
    {
        newSpike();
//         actions();
    }
    
    /**
     * Act - do whatever the Paddle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    
    {
        if(((BubbleWorld) getWorld()).paddlePowerTrue())
        {
            if(Greenfoot.isKeyDown("up"))
            {
                fire();
            }
        }
        if (Greenfoot.isKeyDown ("left")) {
            move(-9);
        }
        if (Greenfoot.isKeyDown ("right")) {
            move(9);
        }
        if (haveSpike() && Greenfoot.isKeyDown ("space")) {
            releaseSpike();
        }
        reloadDelayCount++;
        
    }
    
    private void move(int dist)
    {
        setLocation (getX() + dist, getY());
        if (mySpike != null) {
            mySpike.move (dist);
        }
    }
    
    public void newSpike()
    {
        mySpike = new Spike();
        getWorld().addObject (mySpike, getX(), getY()-22);
    }
        
    public boolean haveSpike()
    {
        return mySpike != null;
    }
        
    public void releaseSpike()
    {
        mySpike.release();
        mySpike = null;

    }
    
    private void fire() 
    {
        if (reloadDelayCount >= gunReloadTime) 
        {
            getWorld().addObject (new Lasers(), getX()+22, getY()-22);
            getWorld().addObject (new Lasers(), getX()-22, getY()-22);
            reloadDelayCount = 0;
            ((BubbleWorld) getWorld()).counter();
        }
    }      
}
